{{
***************************************************************************
*                                                                         *
*       AV_NewBrain_v3.spin                             A. Vreugdenhil    *
*                                                                         * 
*       The Best from the West !!              a.vreugdenhil@hccnet.nl    * 
*                                                                         *
*       De NewBrain-A of NewBrain-AD simulatie door middel van de         *
*       uitlezing van het orginele NewBrain toetsenbord.                  * 
*                                                                         *
*       20120203  1e uitlezing van het NB-toetsenbord.                    *
*       20120211  Zend_waarde blok opgezet, incl pariteit en PS-2.        *
*       20120212  Key_Maak en Key_Verbreek routine's gemaakt.             *
*       20120216  Aanpassing gedaan mbt Home- en Arrow-code's.            *
*       20120318  Laatste toetscode's aangepast, kompleet ingebouwd.      *
*                                                                         *
*                                                                         *
***************************************************************************
}}

CON

  _clkmode = xtal1 + pll16x     ' zorgt voor 80_000_000 clockpulsen per seconde 
  _xinfreq = 5_000_000                   

  Led        = 4        ' de debug-LED
  PS2_clock  = 6        ' PS-2 clock uitgang
  PS2_data   = 7        ' PS-2 data in- en uitgang  
  Monitor    = 8        ' 8, 9 en 10 zijn voor de Monitor uitgang
  Key_clock  = 16       ' clockpuls naar de CD4024
  Key_reset  = 17       ' resetpuls naar de CD4024
  Key_data1  = 18       ' uitgang 0 van de CD14584
  Key_data2  = 19       ' uitgang 1 van de CD14584 
  Key_data3  = 20       ' uitgang 2 van de CD14584 
  Key_data4  = 21       ' uitgang 3 van de CD14584 
  lang       = 2000     ' Lange pauze, tijdens genereren PS-2 signaal, maakt 16 kHz
  kort       = 1000     ' Korte pauze, tijdens genereren PS-2 signaal 

VAR
  byte key
  byte variabele
  byte Key_aanwijzer
  byte Pariteit
  byte toets
  byte gevonden
  byte oud
  byte nieuw
  byte cog
  byte Key_volgorde[10]         ' Buffer met gedrukte toetscombinatie's.
  byte Key_oud[10]              ' Buffer met vorige keer ingedrukte toetscombinatie's.
  long stack[25]                ' te klein dan loopt het video-beeld vast ??????? 
  long temp2
  
OBJ
  fdx     :     "FullDuplexSerial"                      '   Later alle fdx.xx wegvinken
  text    :     "tv_text"                               '   Demo op Monitor uitgang (composite video)
 
PUB start    | i
  dira[Led]~~

  dira[key_clock..Key_reset]~~                          '   Key_clock en reset = uitgang
  dira[key_data1..Key_data4]~                           '   Key_data1 - 4 = ingang
  outa[key_clock..Key_reset]~~                          '   Key_clock en reset = Hoog 
  outa[key_data1..Key_data4]~ 
 
  cognew(beeld,@stack)                                  '   Start doorlopende demo op monitor uitgang op.
  
  fdx.start(31,30,0,9600)                               '   Start seriele uitgang (debug) op.
  fdx.tx(0)                                             '   Wis scherm

  repeat
    key := 0
    outa[Key_reset]~~                                   '   Key_reset = Hoog 
    waitcnt(400 + cnt)                                  '   Wacht kort (80_000_000 = 1 Seconde)
    outa[Key_reset]~                                    '   Key_reset = Laag
    waitcnt(400 + cnt)                                  '   Wacht kort
    Key_aanwijzer := 0
      
'**********************************************************************************************
'*** Scan toetsenbord *************************************************************************
'**********************************************************************************************                                       
    repeat until key > 15
      variabele := ina[Key_data4..Key_data1]            '   Lees de CD14584 uit    
      if variabele <> 0                                 '   <> 0 = toets(en) ingedrukt 
        toets1                                          '             op de betreffende [key] rij
      outa[Key_clock]~                                  '   Key_clock = Laag
      waitcnt(400 + cnt)                                '   Wacht kort
      outa[Key_clock]~~                                 '   Key_clock = Hoog
      waitcnt(400 + cnt)                                '   Wacht kort
      key := key + 1
    
'**********************************************************************************************
'*** Bepaal Key_Press of Key_Release **********************************************************
'*** Doe dit aan de hand van 2 lijstjes en vergelijk deze met elkaar **************************
'**********************************************************************************************                                      
    nieuw := 0                                          '   Key_Maak zoek Routine
    repeat 10     
      if Key_volgorde[nieuw] <> 0                       '   Neem een nieuwe waarde en kijk of er een 
        oud := 0                                        '     \
        gevonden := 0                                   '      \
        repeat 10                                       '       \
          if Key_volgorde[nieuw] == Key_oud[oud]        '        waarde in de oude tabel overeenkomt.
            gevonden := 1
          oud := oud + 1
        if gevonden == 0                                  '   Niets gelijks gevonden?
          Zend_waarde(Key_volgorde[nieuw],1)              '     Zend dan maak code voor Key_volgorde       
      nieuw := nieuw + 1

'**********************************************************************************************                                       
    oud := 0                                            '   Key_Verbreek zoek routine   
    repeat 10 
      if Key_oud[oud] <> 0                              '   Neem een oude waarde en kijk of er een
        nieuw := 0                                      '     \
        gevonden := 0                                   '      \
        repeat 10                                       '       \
          if Key_oud[oud] == Key_volgorde[nieuw]        '        waarde in de nieuwe tabel overeenkomt.
            gevonden := 1
          nieuw := nieuw + 1
        if gevonden == 0                                  '   Niets gelijks gevonden?
          Zend_waarde(Key_oud[oud],0)                     '     Zend dan verbreek code voor Key_oud        
      oud := oud + 1

'**********************************************************************************************
'   verplaats de nieuwe waarde naar de oude lijst en maak nieuwe lijst leeg.
    oud := 0
    repeat 10
      Key_oud[oud] := Key_volgorde[oud]
      Key_volgorde[oud] := 0
      oud := oud + 1
    waitcnt(1_000_000 + cnt)
      
'**********************************************************************************************    
PUB Toets1 | temp , lus
{{
Als een toets ingedrukt is kijk of er meerdere toetsen per scanrij ingedrukt zijn en zet deze allen 
apart in de lijst Key_volgorde[Key_aanwijzer] met een maximum aantal van 10 (moet lager worden.(5 ?))
}}
  lus := 0
  temp := variabele
  repeat until lus > 3 
    if Key_aanwijzer < 10
      if (temp & 0000_0001) 
        Key_volgorde[Key_aanwijzer] := (key<<2) + lus
        Key_aanwijzer := Key_aanwijzer + 1 
    temp := (temp>>1)  
    lus := lus + 1

'**********************************************************************************************    
PUB Zend_Waarde(index,status)                           '   toets nummer, status = maak(1) of verbreek(0)
{{
zoek de scancode op en schuif deze byte's als PS-2 signaal naar buiten.
}}
  fdx.str(string("Toets",13))                     '\
  fdx.dec(index)                                  ' \
  fdx.str(string("  "))                           '  -->    Dit later wegvinken
  fdx.hex(status,1)                               ' /
  fdx.str(string(13))                             '/

  dira[PS2_clock]~~                                     '   richting UIT
  dira[PS2_data]~~                                      '   richting UIT
  outa[PS2_clock]~~                                     '   Clock lijn HOOG
  outa[PS2_data]~~                                      '   Data lijn HOOG
  
  temp2 := long[@key_scan][index]                       '   HIER draait het om, om het opzoeken in een tabel !!!!!!
  if status == 1
    temp2 := (temp2>>8)                                 '   Maak_code = 2e byte beginnen.
    if (temp2 & $ff) == $f0                             '   Als dit F0 is maak er dan EO van,
      temp2 := (temp2 & $ffffe0)                        '     dit voor de Home en Arrow code's
     
  repeat while temp2 <> 0                               '   Temp2 = long met data erin   
    toets := temp2                                      

    pariteit := 1                                       '   Bepaal hier de Odd-Pariteit. (0 voor Even) 
    repeat 8
      pariteit := pariteit + (toets & 1)                '   Telop,
      toets := toets>>1                                 '     en schuif (8 keer).
    pariteit := (pariteit & 1)

    fdx.hex(temp2,8)                                    '   Nog te verzenden (32 bit's) waarde
    fdx.str(string(13))                                 '     Enter
      
    toets := temp2                                      '   Zet rechter byte in toets
    
'**********************************************************************************************
'*** genereren PS-2 signaal *******************************************************************

    outa[PS2_data]~                                     '   Start Bit = Laag   
    waitcnt(kort + cnt)                                 '   Wacht kort  
    outa[PS2_clock]~                                    '   Clock laag
    waitcnt(lang + cnt)                                 '   Wacht kort   
    outa[PS2_clock]~~                                   '   Clock hoog
    waitcnt(kort + cnt)
    
    repeat 8                                            '   Herhaal 8 maal
      outa[PS2_data] := toets                           '       Bit0 op uitgang
      waitcnt(kort + cnt)                               '       Wacht kort  
      outa[PS2_clock]~                                  '       Clock laag
      waitcnt(lang + cnt)                               '       Wacht kort     
      outa[PS2_clock]~~                                 '       Clock hoog
      waitcnt(kort + cnt)
      toets := (toets>>1)                               '     Schuif data naar rechts

    outa[PS2_data] := pariteit                          '   pariteit Bit (Odd = Oneven)
    waitcnt(kort + cnt)                                 '   Wacht kort  
    outa[PS2_clock]~                                    '   Clock laag
    waitcnt(lang + cnt)                                 '   Wacht kort    
    outa[PS2_clock]~~                                   '   Clock hoog

    waitcnt(kort + cnt)
    outa[PS2_data]~~                                    '   Stop Bit = Hoog
    waitcnt(kort + cnt)                                 '   Wacht kort  
    outa[PS2_clock]~                                    '   Clock laag
    waitcnt(lang + cnt)                                 '   Wacht kort     
    outa[PS2_clock]~~                                   '   Clock hoog
    waitcnt(kort + cnt) 
    temp2 := (temp2>>8)

    !outa[Led]                                          '   Toggle LED. 
'**********************************************************************************************

PUB Beeld | temp 
text.start(8)                                           '   Start het videosignaal op pin 8, 9 en 10

repeat
'** 1e Beeld **********************************************************************************
  text.out(00)                                          '   Wisscherm
  waitcnt(40_000_000 + cnt)                             '   Wacht 1/2 seconde
  temp := 0                                         
  repeat until temp > 8                                 '   Zet 9 regels
    text.str(@@Pag1Adr[temp])                           '    \ tekst op het scherm
    waitcnt(40_000_000 + cnt)                           '     \ met telkens 1/2 seconde pauze ertussen
    temp := temp + 1 
  waitcnt(clkfreq * 6 + cnt)                            '   Wacht 6 seconde
  
'** 2e Beeld **********************************************************************************
  text.out(00)                                          '   Wisscherm
  waitcnt(40_000_000 + cnt)                             '   Wacht 1/2 seconde
  temp := 0                                         
  repeat until temp > 12                                '   Zet 13 regels
    text.str(@@Pag2Adr[temp])                           '    \ tekst op het scherm met
    waitcnt(20_000_000 + cnt)                           '     \ telkens 1/4 seconde pauze ertussen
    temp := temp + 1 
  waitcnt(clkfreq * 8 + cnt)                            '   Wacht 8 seconde
  
DAT
'**********************************************************************************************
'*** Tabel van toetsenmatrix-code met Make/Break-code's ***************************************
'**********************************************************************************************  
' Index -->    0     nc   1     nc   2   Stop   3     nc   4      ^   5      <   6      >   7      v   8     J    9     7    10    8    11    U    12    N    13    6    14    9    15    I    16    M    17    5    18    0    19    Y    20    ,    21    4    22    ([   23    O    24    .    25    3    26    )]   27    L    28    B    29    2    30    *    31    ;    32    V    33    1    34  VidT   35    H    36    C    37    T    38    P    39    G    40    X    41    R    42    =    43    F    44    Z    45    E    46    -    47    D    48  Inse   49    W    50    +    51    S    52    K    53    Q    54  NewL   55    A    56  Home   57 Space   58   Esc   59    /    60  Ctrl   61 Repea   62 Graph   63 Shift 
key_scan long $00000001, $00000002, $0071f0e0, $00000004, $0075f0e0, $006bf0e0, $0074f0e0, $0072f0e0, $00003bf0, $00003df0, $00003ef0, $00003cf0, $000031f0, $000036f0, $000046f0, $000043f0, $00003af0, $00002ef0, $000045f0, $000035f0, $000041f0, $000025f0, $000054f0, $000044f0, $000049f0, $000026f0, $00005bf0, $00004bf0, $000032f0, $00001ef0, $00007cf0, $00004cf0, $00002af0, $000016f0, $000011f0, $000033f0, $000021f0, $00002cf0, $00004df0, $000034f0, $000022f0, $00002df0, $000055f0, $00002bf0, $00001af0, $000024f0, $00004ef0, $000023f0, $0070f0e0, $00001df0, $000079f0, $00001bf0, $000042f0, $000015f0, $00005af0, $00001cf0, $006cf0e0, $000029f0, $000076f0, $00004af0, $000014f0, $00007ef0, $000066f0, $000012f0  

'**********************************************************************************************  
'*** 1e Pagina met info ***********************************************************************
'**********************************************************************************************  
regel1 byte "NewBrain-ig presenteert de NewBrain-USB" ,13,13, 0
regel2 byte "       Bijeenkomst zaterdag 12 Mei 2012" ,13,13, 0
regel3 byte "Presentatie van ondermeer:             " ,13,13, 0
regel4 byte "    NewBrain-USB Toetsenbord           " ,13, 0
regel5 byte "    USB --> LPT omzetter  (mmv B+ club)" ,13, 0
regel6 byte "    Status TetraBot       (mmv   AI-ig)" ,13, 0
regel7 byte "    NewBrain in het nieuws             " ,13,13, 0
regel8 byte "En veel meer NewBrain  |               " ,13, 0
regel9 byte "   ontwikkelingen.     |  @2012 AV_Tech" , 0

Pag1Adr word @regel1, @regel2, @regel3, @regel4, @regel5, @regel6, @regel7, @regel8, @regel9

'**********************************************************************************************  
'*** 2e Pagina met info ***********************************************************************
'**********************************************************************************************  
regel11 byte "    *** Retronica ***                  " ,13, 0
regel12 byte "                                       " ,13, 0
regel13 byte "Voor meer informatie:                  " ,13, 0
regel14 byte "                                       " ,13, 0
regel15 byte "    http://www.newbrain.nl             " ,13, 0
regel16 byte "    https://sites.google.com/          " ,13, 0
regel17 byte "                    site/bpluswestland/" ,13, 0
regel18 byte "                                       " ,13, 0
regel19 byte "  Let op !!!  Dit is pas het begin     " ,13, 0
regel20 byte "                                       " ,13, 0
regel21 byte "    Er komen nog       |       Westland" ,13, 0
regel22 byte "   meer  NewBrain      |               " ,13, 0
regel23 byte "   ontwikkelingen.     |  @2012 AV_Tech" , 0

Pag2Adr word @regel11, @regel12, @regel13, @regel14, @regel15, @regel16, @regel17, @regel18, @regel19, @regel20, @regel21, @regel22, @regel23      



   